<!DOCTYPE html>
<html>

<head>
    <title>{title} - Queue Status</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0/dist/css/bootstrap.min.css" rel="stylesheet">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0-beta3/css/all.min.css">
    <style>
        :root {
            --primary-bg: #f8f9fa;
            --card-shadow: rgba(0, 0, 0, 0.1) 0px 4px 12px;
            --failed-color: #dc3545;
            --pending-color: #ffc107;
            --success-color: #198754;
            --running-color: #0dcaf0;
        }

        body {
            background-color: #6c6c6c;
            font-family: 'Segoe UI', system-ui, -apple-system, sans-serif;
            min-height: 100vh;
        }

        * {
            font-size: 0.8rem;
        }

        .container {
            max-width: 1400px;
        }

        .header-app {
            background-color: #2c3e50;
            color: white;
            padding: 1rem;
            border-radius: 12px;
        }

        .card {
            border: none;
            border-radius: 12px;
            box-shadow: var(--card-shadow);
            transition: transform 0.2s ease;
            margin-bottom: 1.5rem;
            cursor: move;
        }

        .card:hover {
            transform: translateY(-5px);
        }

        .card-header {
            border-radius: 12px 12px 0 0 !important;
            /* padding: 1rem; */
        }

        .card-title {
            font-size: 1.2rem;
            font-weight: 600;
            margin: 0;
        }

        .card-body {
            font-size: 0.7rem;
        }

        .table {
            margin-bottom: 0;
            float: left;
        }

        .table thead th {
            border-bottom: 2px solid #dee2e6;
            font-weight: 600;
            color: #495057;
            font-size: 0.8rem;
        }

        .table td {
            vertical-align: middle;
            color: #6c757d;
            font-size: 0.8rem;
        }

        /* Cards específicos */
        .bg-danger {
            background: linear-gradient(45deg, var(--failed-color), #e35d6a) !important;
        }

        .bg-warning {
            background: linear-gradient(45deg, var(--pending-color), #ffcd39) !important;
        }

        .bg-success {
            background: linear-gradient(45deg, var(--success-color), #27ae60) !important;
        }

        .bg-info {
            background: linear-gradient(45deg, var(--running-color), #17a2b8) !important;
        }

        .badge {
            position: absolute;
            right: 10px;
            top: 6px;
            background-color: #f1f1f1 !important;
            color: #000 !important;
        }

        /* Responsividade para tabelas */
        @media (max-width: 768px) {
            .table-responsive {
                display: block;
                width: 100%;
                overflow-x: auto;
            }

            .card {
                margin-bottom: 1rem;
            }
        }

        /* Animação de loading */
        @keyframes pulse {
            0% {
                opacity: 1;
            }

            50% {
                opacity: 0.5;
            }

            100% {
                opacity: 1;
            }
        }

        .loading {
            animation: pulse 1.5s infinite;
        }

        .dragging {
            opacity: 0.5;
            transform: scale(0.95);
        }
    </style>
</head>

<body>
    <div class="container">
        <div class="row header-app">
            <div class="col-md-3"></div>
            <div class="col-md-6">
                <h2 class="text-center">{title} - Queue Status Panel</h2>
            </div>
            <div class="col-md-3">
                <div class="text-end">
                    <small>
                        <i class="fa fa-clock"></i>
                        <i>Last update: <span id="last-update"></span></small></i>
                    </small>
                </div>
            </div>
        </div>

        <div class="row mt-4">
            <div class="col-md-8">
                <div class="card">
                    <div class="card-header bg-success text-white">
                        <h5 class="card-title mb-0"><i class="fa fa-users"></i> Execution</h5>
                        <span class="badge badge-info d-none" id="new-itens-badge"><i class="fa fa-eye"></i></span>
                    </div>
                    <div class="card-body" id="execution-container"></div>
                </div>
            </div>
            <div class="col-md-4">
                <div class="card">
                    <div class="card-header bg-success text-white">
                        <h5 class="card-title mb-0"><i class="fa fa-users"></i> Active Runners<span
                                class="badge">0</span></h5>
                    </div>
                    <div class="card-body" id="runners-container"></div>
                </div>
            </div>
            <div class="col-md-4">
                <div class="card">
                    <div class="card-header bg-danger text-white">
                        <h5 class="card-title mb-0"><i class="fa fa-exclamation-triangle"></i> Failed Tasks
                            <span class="badge">0</span>
                        </h5>
                    </div>
                    <div class="card-body" id="failed-container"></div>
                </div>
            </div>

            <div class="col-md-4">
                <div class="card">
                    <div class="card-header bg-warning">
                        <h5 class="card-title mb-0"><i class="fa fa-clock"></i> Pending Tasks
                            <span class="badge">0</span>
                        </h5>
                    </div>
                    <div class="card-body" id="pending-container"></div>
                </div>
            </div>
            <div class="col-md-4">
                <div class="card">
                    <div class="card-header bg-info">
                        <h5 class="card-title mb-0"><i class="fa fa-running"></i> Running Tasks
                            <span class="badge">0</span>
                        </h5>
                    </div>
                    <div class="card-body" id="running-container"></div>
                </div>
            </div>
        </div>

        <script>
            let fetchingData = false;

            const titleOriginal = document.title;

            function localTimezone(stringDate) {
                if (!stringDate) return '';

                const utcDate = new Date(stringDate + 'Z');

                return utcDate.toLocaleString(navigator.language, {
                    year: 'numeric',
                    month: '2-digit',
                    day: '2-digit',
                    hour: '2-digit',
                    minute: '2-digit',
                    second: '2-digit'
                });
            }

            function updateData() {
                if (fetchingData) {
                    return;
                }

                fetchingData = true;
                fetch('{urlToLoadData}')
                    .then(response => response.json())
                    .then(data => {
                        document.getElementById('new-itens-badge').classList.add('d-none');
                        if (data.hasNewItens) {
                            document.getElementById('new-itens-badge').classList.remove('d-none');
                        }

                        let pendingHtml = '<table class="table table-sm"><thead><tr><th>Handler</th><th>Priority</th><th>Async</th><th>Count</th></tr></thead><tbody>';
                        let counter = 0;
                        data.pending.forEach(item => {
                            pendingHtml += `<tr><td>${item.handler}</td><td>${item.priority}</td><td>${item.assync}</td><td>${item.counter}</td></tr>`;
                            counter += item.counter;
                        });
                        pendingHtml += '</tbody></table>';
                        document.getElementById('pending-container').innerHTML = pendingHtml;
                        document.getElementById('pending-container').parentElement.querySelector('.badge').textContent = counter;

                        let runningHtml = '<table class="table table-sm"><thead><tr><th>Handler</th><th>Priority</th><th>Runner</th><th>Count</th></tr></thead><tbody>';
                        counter = 0;
                        data.running.forEach(item => {
                            runningHtml += `<tr><td>${item.handler}</td><td>${item.priority}</td><td>${item.runner}</td><td>${item.counter}</td></tr>`;
                            counter += item.counter;
                        });
                        runningHtml += '</tbody></table>';
                        document.getElementById('running-container').innerHTML = runningHtml;
                        document.getElementById('running-container').parentElement.querySelector('.badge').textContent = counter;

                        let failedHtml = '<table class="table table-sm"><thead><tr><th>Handler</th><th>Priority</th><th>Counter</th></tr></thead><tbody>';
                        counter = 0;
                        data.faileds.forEach(item => {
                            failedHtml += `<tr><td>${item.handler}</td><td>${item.priority}</td><td>${item.counter}</td></tr>`;
                            counter += item.counter;
                        });
                        failedHtml += '</tbody></table>';
                        document.getElementById('failed-container').innerHTML = failedHtml;
                        document.getElementById('failed-container').parentElement.querySelector('.badge').textContent = counter;

                        let runnersHtml = '<table class="table table-sm"><thead><tr><th>Runner</th><th>Type</th><th>Started At</th></tr></thead><tbody>';
                        counter = 0;
                        data.runners.forEach(runner => {
                            const localStartedAt = localTimezone(runner.startedAt);
                            runnersHtml += `<tr><td>${runner.name}</td><td>${runner.queueType}</td><td>${localStartedAt}</td></tr>`;
                            counter++;
                        });
                        runnersHtml += '</tbody></table>';
                        document.getElementById('runners-container').innerHTML = runnersHtml;
                        document.getElementById('runners-container').parentElement.querySelector('.badge').textContent = data.runners.length;

                        let executionHTml = '<div class="row">';
                        executionHTml += `<div class="col border-end"><h6 class="text-center text-warning">Pending</h6><p class="text-center fs-1">${parseInt(data.statistics.pendingItems).toLocaleString('pt-BR')}</p></div>`;
                        executionHTml += `<div class="col border-end"><h6 class="text-center text-info">Running</h6><p class="text-center fs-1">${parseInt(data.statistics.runningItems).toLocaleString('pt-BR')}</p></div>`;
                        executionHTml += `<div class="col border-end"><h6 class="text-center text-danger">Failed</h6><p class="text-center fs-3">${parseInt(data.statistics.failedItems).toLocaleString('pt-BR')}</p></div>`;
                        executionHTml += `<div class="col border-end"><h6 class="text-center text-secondary">Total</h6><p class="text-center fs-3">${parseInt(data.statistics.totalItems).toLocaleString('pt-BR')}</p></div>`;
                        executionHTml += `<div class="col border-end"><h6 class="text-center text-success">Items/s</h6><p class="text-center fs-4">${data.statistics.itemsPerSecond}</p></div>`;
                        executionHTml += `<div class="col border-end"><h6 class="text-center text-primary">Estimate</h6><p class="text-center fs-5">${data.statistics.estimatedCompletionAt ? localTimezone(data.statistics.estimatedCompletionAt) : ''}</p></div>`;
                        executionHTml += `<div class="col border-end"><h6 class="text-center text-primary">CPU Usage</h6><p class="text-center fs-6">${data.usage.cpu}%</p></div>`;
                        executionHTml += `<div class="col"><h6 class="text-center text-primary">Memory</h6><p class="text-center fs-6">${data.usage.memory / 1024 / 1024}GB</p></div>`;
                        executionHTml += '</div>';
                        document.getElementById('execution-container').innerHTML = executionHTml;


                        document.getElementById('last-update').textContent = new Date().toLocaleString();



                        document.title = `(${parseInt(data.statistics.runningItems).toLocaleString('pt-BR')}/${parseInt(data.statistics.pendingItems).toLocaleString('pt-BR')}) ${titleOriginal}`;
                    });

                fetchingData = false;
            }

            document.addEventListener('DOMContentLoaded', () => {
                updateData();
                setInterval(updateData, 3000);

                const cards = document.querySelectorAll('.card');
                const containers = document.querySelectorAll('.col-md-4, .col-md-6, .col-md-12');

                cards.forEach(card => {
                    card.setAttribute('draggable', true);

                    card.addEventListener('dragstart', () => {
                        card.classList.add('dragging');
                    });

                    card.addEventListener('dragend', () => {
                        card.classList.remove('dragging');
                    });
                });

                containers.forEach(container => {
                    container.addEventListener('dragover', e => {
                        e.preventDefault();
                        const draggable = document.querySelector('.dragging');
                        container.appendChild(draggable);
                    });
                });
            });
        </script>
</body>

</html>